//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.axtp.tid;
import java.util.*;
import java.beans.*;

/**
 * A bean for generating TID's.
 */
public class SimpleTIDFactory implements TIDFactory
{
	private int tidLength=24;
	private static Random random=new Random();

	public void setTIDLength(int v)
	{
		if (!Beans.isDesignTime())
			throw new Error("not DesignTime");
		if (v<8)
			v=8;
		tidLength=v;
	}

	public int getTIDLength()
	{
		return tidLength;
	}

	public byte[] createTID()
	{
		byte[] b=new byte[tidLength];
		long t=System.currentTimeMillis();
		int i;
		for (i=7;i>-1;--i)
		{
			b[i]=(byte)(t&255);
			t>>=8;
		}
		if (tidLength==8)
			return b;
		byte[] c=new byte[tidLength-8];
		random.nextBytes(c);
		for (i=8;i<tidLength;++i)
			b[i]=c[i-8];
		return b;
	}
}
