//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.axtp.tp;
import ORG.opengroup.axtp.*;
import ORG.opengroup.axtp.transaction.*;
import java.io.*;
import java.net.*;
import java.util.*;

public interface TransactionServer extends TransactionContext
{
	public void setClientAddress(InetAddress clientAddress);
	public InetAddress getClientAddress();
	public void setClientPort(int clientPort);
	public int getClientPort();
	public void setPrimary(boolean primary);
	public boolean getPrimary();
	public boolean isPrimary();
	public void setDuration(long v);
	public long getExpiration();

	public void sendToClient(TransactionObject to);
	public void send(PacketObject po);
	public long setTimer(ExecutionContext xc, long delay);
	public void clearTimer(ExecutionContext xc);
	public RetryDelay cloneRetryDelay();
	public TransactionFactory getTransactionFactory();
	public boolean isNoisy();
}
