//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

import java.net.*;
import java.io.*;
import java.beans.*;
import java.util.*;

public class BiMix implements Serializable, Runnable
{
	public boolean echo=true;
	public long delay=10;
	public int port0=345;
	public int port1=346;
	public int port2=347;

	public boolean getEcho()
	{
		return echo;
	}

	public boolean isEcho()
	{
		return echo;
	}

	public void setEcho(boolean v)
	{
		echo=v;
	}

	public long getDelay()
	{
		return delay;
	}

	public void setDelay(long v)
	{
		delay=v;
	}

	public int getPort0()
	{
		return port0;
	}

	public void setPort0(int v)
	{
		port0=v;
	}

	public int getPort1()
	{
		return port1;
	}

	public void setPort1(int v)
	{
		port1=v;
	}

	public int getPort2()
	{
		return port2;
	}

	public void setPort2(int v)
	{
		port2=v;
	}

    public BiMix()
    {
        if (!Beans.isDesignTime())
	  {
            new Thread(this).start();
        }
    }

    private void writeObject(ObjectOutputStream s)
        throws IOException
    {
        s.defaultWriteObject();
    }

    private void readObject(ObjectInputStream s)
        throws ClassNotFoundException, IOException 
    {
        s.defaultReadObject();
        if (!Beans.isDesignTime())
            new Thread(this).start();
    }


	public void run()
	{
		if (echo)
		{
			System.out.println("Begin BiMix");
			System.out.println("port0="+port0);
			System.out.println("port1="+port1);
			System.out.println("port2="+port2);
		}
		try
		{
			Vector dv1=new Vector();
			Vector dv2=new Vector();
			DatagramSocket ds1=new DatagramSocket(port1);
			DatagramSocket ds2=new DatagramSocket();
			Reader r1=new Reader(ds1,dv1);
			new Thread(r1).start();
			Writter w1=new Writter(ds2,dv1,port2);
			new Thread(w1).start();
			Reader r2=new Reader(ds2,dv2);
			new Thread(r2).start();
			Writter w2=new Writter(ds1,dv2,port0);
			new Thread(w2).start();
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public class Reader implements Runnable
	{
		DatagramSocket ds;
		Vector dv;

		public Reader(DatagramSocket ds, Vector dv)
		{
			this.ds=ds;
			this.dv=dv;
		}

		public void run()
		{
			try
			{
				while(true)
				{
					byte[] b=new byte[10000];
					DatagramPacket dp=new DatagramPacket(b,b.length);
					ds.receive(dp);
					dv.addElement(dp);
				}
			} catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}
	public class Writter implements Runnable
	{
		DatagramSocket ds;
		Vector dv;
		int port;

		public Writter(DatagramSocket ds, Vector dv, int port)
		{
			this.ds=ds;
			this.dv=dv;
			this.port=port;
		}

		public void run()
		{
			try
			{
				while(true)
				{
					while(dv.isEmpty())
						Thread.sleep(1);
					int s=dv.size();
					int q=(int)(s*Math.random());
					if (q==s)
						q=0;
					DatagramPacket dp=(DatagramPacket)dv.elementAt(q);
					if (Math.random()<.7)
						dv.removeElementAt(q);
					dp.setPort(port);
					if (Math.random()<.7)
						ds.send(dp);
					Thread.sleep((int)(delay*Math.random()));
				}
			} catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}
}