//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.axtp.xface;
import ORG.opengroup.axtp.*;
import ORG.opengroup.xface.*;
import ORG.opengroup.jar.*;
import java.util.*;

/**
 * One possible implementation for ExecutionObject.
 */
public class XExecutionObject 
	extends XTransactionObject
	implements ExecutionObject
{
	private long xid=-1L;

	public void setXObj(XObj xObj)
		throws NumberFormatException, Invalid64Exception
	{
		super.setXObj(xObj);
		String t=xObj.getAtt("XID");
		if (t!=null)
			xid=Long.parseLong(t);
	}

	public void setXID(long xid)
	{
		this.xid=xid;
	}

	public long getXID()
	{
		return xid;
	}

	public void setContent(Object content)
	{
		Vector v1=(Vector)xObj.getContents();
		if (v1==null)
			return;
		Vector v2=(Vector)content;
		v1.removeAllElements();
		int i;
		int s=v2.size();
		for (i=0;i<s;++i)
			v1.addElement(v1.elementAt(i));
	}

	public Object getContent()
	{
		return xObj.getContents();
	}

	/**
	 * Refreshes the XML object with current data held by the face object.
	 * (Called by XObj.toString().)
	 */
	public void refreshXObj()
	{
		super.refreshXObj();
		xObj.putAtt("XID",""+xid);
	}
}
